unit TernarySeries;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, VclTee.TeeGDIPlus, Vcl.ExtCtrls,
  VCLTee.TeEngine, VCLTee.TeeSurfa, VCLTee.TeeTernary, Vcl.StdCtrls,
  VCLTee.TeeProcs, VCLTee.Chart, VCLTee.TeeURL, VCLTee.TeeSeriesTextEd, Data.DB,
  kbmMemTable, commasplit, kbmMemCSVStreamFormat;

type
  TTernarySeriesForm = class(TForm)
    Chart1: TChart;
    Button1: TButton;
    Series1: TTernarySeries;
    Panel1: TPanel;
    SeriesTextSource1: TSeriesTextSource;
    kbmMemTable1: TkbmMemTable;
    kbmCSVStreamFormat1: TkbmCSVStreamFormat;
    DataSource1: TDataSource;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Chart1BeforeDrawAxes(Sender: TObject);
  private
//    kbmCSVStreamFormat1: TkbmCSVStreamFormat;
    function Loadfile(filename: Tfilename): boolean;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  TernarySeriesForm: TTernarySeriesForm;

implementation

{$R *.dfm}

Uses EditChar, TeeConst;

procedure TTernarySeriesForm.Button1Click(Sender: TObject);
begin
  EditSeries(Self,Series1);
end;

procedure TTernarySeriesForm.Chart1BeforeDrawAxes(Sender: TObject);
begin
  Chart1.Legend.Title.Visible := Series1.ColorEachPoint;
end;

procedure TTernarySeriesForm.FormCreate(Sender: TObject);
var
  z: boolean;
  Lkbm: TkbmMemTable;
  af: TFieldDefs;
  i: integer;

begin
  inherited;

  kbmMemTable1 := TkbmMemTable.Create(nil);
  kbmMemTable1.DefaultFormat := kbmCSVStreamFormat1;
  kbmMemTable1.CommaTextFormat := kbmCSVStreamFormat1;

  af := kbmMemTable1.FieldDefs;

  with af.AddFieldDef do
  begin
    Name := 'Sample Site';       // Text
    DataType := ftString;
    Name := 'Sample Date';
    DataType := ftString;
    Name := 'TD Na/1000';        // X
    DataType := ftFloat;
    Name := 'sqr(TD Mg)';        // Y
    DataType := ftFloat;
    Name := 'TD K/100';          // Z
    DataType := ftFloat;
    Name := 'Conc Sum';          // Radius
    DataType := ftFloat;
  end;

  kbmMemTable1.Open;
  kbmMemTable1.LoadFromFile('C:\Code_Test_Progs\TernaryGraph\Na-Mg-K.csv');
  i := kbmMemTable1.RecordCount;

// Load Na Mg K data
  DataSource1.DataSet := kbmMemTable1;
  Series1.DataSource := DataSource1;

  Series1.UseColorRange:=false;
//  Series1.UseColorRange:=true;
  Series1.VertexTitles[0][0] := 'Na/1000' ;
  Series1.VertexTitles[1][0] := 'Sqr(Mg)' ;
  Series1.VertexTitles[2][0] := 'K/100' ;


  Series1.Pointer.Style:=psCircle;
  Series1.Pointer.Transparency:=50;

  Series1.TernaryStyle:=tsBubble;
//  Series1.TernaryStyle:=tsPoint;
  Series1.TernaryLegendStyle:=tlsBubbleWeight;

//  Chart1.Legend.Title.Text.Add(TeeMsg_TernaryMarkRadius + ', ' + TeeMsg_TernaryMarkWeight);
  Chart1.Legend.TextStyle := ltsPlain;
  Chart1.Legend.Title.Text.Add('Sample Site  Sample Date');
  Chart1.Legend.Title.TextAlignment := taLeftJustify;
  Chart1.Legend.Width :=30;
  Chart1.Legend.Title.Visible:=true;
end;

function TTernarySeriesForm.Loadfile(filename: Tfilename): boolean;
var
  LFile: TextFile;
  LStr, LTempS: string;
  LRow,LCol: integer;
  P: integer;
  Lcs: Tcommasplitter;

begin
//  AssignFile(LFile, filename);
//  reset(LFile);
//  Readln(LFile,Lcs);
//  LRow := 0;
//  if pos(',',LStr) > 0 then
//  begin
////    StatusBar.Panels[2].text := 'READING CSV DATA';
////    sleep(500);
//    // comma read
//    LCol := 0;
//    reset(LFile);
//    while not eof(LFile) do
//    begin
//      Readln(LFile,LStr);
////      if pos(Filter,LStr) > 0 then
////      begin
////        inc(LRow);
////        Table.rowcount := LRow + 1;
////
////        for P := 1 to length(LStr) do
////        if copy(LStr,P,1) <> ',' then
////          LTempS := LTempS + copy(LStr,P,1)
////        else
////        begin
////          Table.Cells[LCol,LRow] := LTempS;
////          LTempS := '';
////          inc(LCol);
////        end;
////
////        if LCol = 5 then
////        begin
////          Table.Cells[C,LRow] := LTempS;
////          LTempS := '';
////          LCol := 0;
////        end;
////      end;
//    end;
////    Itemcount := LRow;
////    Table.repaint;
//    LoadFile := true;
////    StatusBar.Panels[2].text := 'DATA LOADED';
//
//  end
//  else
//  begin
//    showmessage('Data file format error. Not loaded');
////    StatusBar.Panels[2].text := 'NO DATA LOADED';
//    Loadfile := False;
//  end;
//  CloseFile(LFile);
////  with table do
////    if (atbottom.checked) and (rowcount > 10) then
////      TopRow := rowcount - ((Height div 20)-1);
////    StatusBar.Panels[0].text := DataFilename;
////    StatusBar.Panels[1].text := inttostr(itemcount);
end;

end.
